(***************************************************************************

(This sentence has been added automatically, it should be replaced by a description of the module)

CiME Project - Dmons research team - LRI - Universit Paris XI

$Id: mapord.mli,v 1.2 1998/04/28 13:35:00 marche Exp $

***************************************************************************)

(* $Id: mapord.mli,v 1.2 1998/04/28 13:35:00 marche Exp $ *)

module type OrderedType =
  sig
    type t
    val compare: t -> t -> int
  end

module type OrderedMap =
  sig
    type key
    type 'a t
    val empty: 'a t
    val add: key -> 'a -> 'a t -> 'a t
    val find: key -> 'a t -> 'a
    val remove: key -> 'a t -> 'a t
    val iter: (key -> 'a -> unit) -> 'a t -> unit
    val map: ('a -> 'b) -> 'a t -> 'b t
    val fold: (key -> 'a -> 'b -> 'b) -> 'a t -> 'b -> 'b
    val max: 'a t -> key * 'a
    val min: 'a t -> key * 'a
    val elements_increasing_order: 'a t -> (key * 'a) list
  end

module Make(Ord: OrderedType) : OrderedMap with type key=Ord.t;;
