open Num;;

val zero : num
val one : num
val two : num
val minus_one : num

val denominator : num -> num

val power_num : num -> int -> num

val pgcd : num -> num -> num
val full_pgcd : num -> num -> num * num * num
val ppcm : num -> num -> num

val div_floor : num -> num -> num
val div_ceil : num -> num -> num
val sqrt_floor : num -> num
val sqrt_ceil : num -> num
val root_floor : int -> num -> num
val root_ceil : int -> num -> num
