(***************************************************************************

Critical equations : specifications

CiME Project - Dmons research team - LRI - Universit Paris XI

$Id: critical_equations.mli,v 1.1 2000/05/16 17:36:39 monate Exp $

***************************************************************************)

(*

Obsolete header:

Project: Cime

Last modified by: $Author: monate $
File name:        $Source: /users/demons/demons/master-sources-repository//cime/ocaml_src/oldcimroot/critical_equations.mli,v $
Revision:         $Revision: 1.1 $ 
Last modified on: $Date: 2000/05/16 17:36:39 $

***************************************************************************)

open Terms
open Positions
open Substitution

(*============================

Compute critical equations obtained form critical pairs, removing
those where substitution is S-reducible

=============================*)

val make_critical_equations :
  (term * term * substitution) list *
  (term * term * position * term * substitution) list
  -> (term * term) list
