(***************************************************************************

(This sentence has been added automatically, it should be replaced by a description of the module)

CiME Project - Dmons research team - LRI - Universit Paris XI

$Id: llist.mli,v 1.1 2000/05/16 17:36:44 monate Exp $

***************************************************************************)


type 'a frozen = 
   Freeze of (unit -> 'a)
 | Val of 'a;;

type 'a llist =
   Nil
 | Cons of 'a cell

and 'a cell = 
    {         tete : 'a;
      mutable queue : 'a llist frozen
    }
;;

val hdl : 'a llist -> 'a;;

val tll : 'a llist -> 'a llist;;

val lmem : 'a -> 'a llist -> bool;;

val mapl : ('a -> 'b) -> 'a llist -> 'b llist;;

val flat_mapl : ('a -> 'b llist) -> 'a llist -> 'b llist;;

val flat_map2 : ('a -> 'b llist) -> 'a list -> 'b llist;;

val do_llist : ('a -> 'b) -> int -> 'a llist -> unit;;

val do_all_llist : ('a -> 'b) -> 'a llist -> unit;;

val llist_it : ('a -> 'b -> 'b) -> 'a llist -> 'b -> 'b;;

val appendl : 'a llist -> 'a llist frozen -> 'a llist;;

val list_to_llist : 'a list -> 'a llist;;

val llist_to_list : 'a llist -> 'a list;;

val lazy_exists : ('a -> bool) -> 'a llist -> bool;;

val lazy_assoc : 'a -> ('a * 'b) llist -> 'b;;

val llist_length : 'a llist -> int;;

val llist_copy : 'a llist -> 'a llist;;
