(***************************************************************************
  (This sentence has been added automatically, it should be replaced
  by a description of the module)

CiME Project - Dmons research team - LRI - Universit Paris XI

$Id: parallel.mli,v 1.4 2001/06/07 13:54:12 monate Exp $

***************************************************************************)

module M : sig

(* [compute f s accumulation acc] computes for each element [s0,s1,...] of
   the stream [s] a permutation of the list [l=[f s0;f s1;...]] then
   [List.fold accumulation l acc]. Read [parallel.nopvm] if unclear...*)

  val compute : ('a -> 'b) -> 'a Stream.t -> ('b -> 'c -> 'c) -> 'c -> 'c

(* Am I the server ? Not for casual user.*)
  val is_god : unit -> bool

(* Number of client to be launched by [init_server]. Not for casual user.*)
  val max_process : int ref

(* To be called only once close to program start. Not for casual user.*)
  val init_server : unit -> unit

(* To be called by the client at startup. It starts the loop of the
   client until he dies. Not for casual user.*)
  val computer_client : unit -> unit

(* Do we use multiple processes ? Not for casual user. *)
  val smp : bool ref

end
