(* open Regular_expr *) 

let count l = 
  let left_members = List.map fst l in
  let signature = List.fold_left
		    (fun acc left_member -> 
		       Automata.CharSet.union 
			 (List.fold_left (fun acc x -> 
					    Automata.CharSet.add x acc) acc
			    left_member)
			 acc)
		    Automata.CharSet.empty
		    left_members
  in
  Automata.count_nf signature left_members (String_rewriting.compile_srs l)

(*
  let exprs = List.map (fun w -> 
			  seq
			  (star all_chars) 
			  (List.fold_left 
			       (fun acc x -> seq (char x) acc) (star all_chars)
			       w) )
		left_members in
  let expr = List.fold_left (fun acc x -> alt x acc) empty exprs in
  Automata.count_words (Automata.compl signature (Automata.compile expr))

*)
