(***************************************************************************

  This module provides usual narrowing functions on a term wrt. a set of
  rules.  The signature may or may not contain only free function symbols.

  CiME Project - Dmons research team - LRI - Universit Paris XI
  
  $Id: innermost_narrowing.mli,v 1.2 2002/07/16 16:03:47 contejea Exp $

***************************************************************************)

open Gen_terms

type 'symbol constraints = ('symbol term * 'symbol term) list

(*
module NarSet : 
  Ordered_sets.OrderedSet 
  with type 'symbol elt = 
    Variables.var_id * ('symbol term  * 'symbol term) * 'symbol constraints
*)

val init : 
  ('symbol term * 'symbol term) -> 
    Variables.var_id * ('symbol term * 'symbol term) * 'symbol constraints

val one_step_standard :
  'symbol #Signatures.signature -> 'symbol HashTerm.t ->
    'symbol term Orderings_generalities.ordering ->
      ('symbol Rewrite_rules.t list * 'symbol Naive_dnet.dnet) ->
	Variables.var_id * ('symbol term * 'symbol term) * 'symbol constraints ->
	  (Variables.var_id * ('symbol term * 'symbol term) * 'symbol constraints) list

val one_step_ac :
  'symbol #Signatures.signature -> 'symbol HashTerm.t ->
    'symbol term Orderings_generalities.ordering ->
      ('symbol Rewrite_rules.t list * 'symbol Naive_dnet.dnet) ->
	Variables.var_id * ('symbol term * 'symbol term) * 'symbol constraints ->
	  (Variables.var_id * ('symbol term * 'symbol term) * 'symbol constraints) list



