(***************************************************************************

Ordering on polynomials

CiME Project - Dmons research team - LRI - Universit Paris XI

$Id: poly_ordering.mli,v 1.3 2001/01/31 16:08:33 monate Exp $

***************************************************************************)

open Orderings
open Poly

(*

  ordre d'evaluation sur les polynomes

  [(compare_poly P Q)] retourne

  [Equivalent]            si pour tt x1.. xn P(x1..xn)=Q(x1..xn)
  [Greater]               si pour tt x1.. xn P(x1..xn)>Q(x1..xn)
  [Less_than]             si pour tt x1.. xn P(x1..xn)<Q(x1..xn)
  [Greater_or_equivalent] si pour tt x1.. xn P(x1..xn)>=Q(x1..xn)
  [Less_or_equivalent]    si pour tt x1.. xn P(x1..xn)>=Q(x1..xn)
  [Uncomparable]          sinon

bien sur c'est imcomplet : en fait la specification est :

  si [(compare_poly P Q)] retourne

  [Equivalent]            alors pour tt x1.. xn P(x1..xn)=Q(x1..xn)
  [Greater]               alors pour tt x1.. xn P(x1..xn)>Q(x1..xn)
  [Less_than]             alors pour tt x1.. xn P(x1..xn)<Q(x1..xn)
  [Greater_or_equivalent] alors pour tt x1.. xn P(x1..xn)>=Q(x1..xn)
  [Less_or_equivalent]    alors pour tt x1.. xn P(x1..xn)>=Q(x1..xn)
  [Uncomparable]          alors on ne sait rien

*)

val compare_poly : polynome -> polynome -> comparison_result

