(***************************************************************************

Checking termination of a rewrite system by the basic criterion

CiME Project - Dmons research team - LRI - Universit Paris XI

$Id: basic_criterion.ml,v 1.5 1999/06/04 14:45:00 marche Exp $

***************************************************************************)

open Rewrite_rules;;

open Termination_constraints;;

(*
let rec all_decreasing order = function
    [] -> true
  | rule::l ->
      if order (rule.l,rule.r)=Greater
      then all_decreasing order l
      else
	begin
	  message "The following rule:";
	  print_regle rule;
	  force_newline ();
	  message "is not decreasing.";
	  false
	end
;;
*)



let all_decreasing_constraints rules =
  List.fold_right 
    (fun rule accu ->
       AtomicTerminationConstraintSet.add
	 { left = rule.lhs ;
	   right = rule.rhs ;
	   constraint_op = Greater
	 }
	 accu)
    rules
    AtomicTerminationConstraintSet.empty
;;
