(***************************************************************************

Checking termination of a rewrite system by the basic criterion

CiME Project - Dmons research team - LRI - Universit Paris XI

$Id: old_basic_criterion.ml,v 1.2 1999/02/17 12:42:44 contejea Exp $

***************************************************************************)

open Orderings;;
open Messages;;
open Equations;;
open Format;;

let rec all_decreasing order = function
    [] -> true
  | rule::l ->
      if order rule.l rule.r = Greater
      then all_decreasing order l
      else
	begin
	  message "The following rule:";
	  print_regle rule;
	  force_newline ();
	  message "is not decreasing.";
	  false
	end


