(***************************************************************************

Calcul du couple_normalisant pour ACUN(+,0) : interface

CiME Project - Dmons research team - LRI - Universit Paris XI

$Id: acun.mli,v 1.2 1998/04/28 13:36:44 marche Exp $

***************************************************************************)

(*

Obsolete header:


Project:                Cime
Created on:              06 mai 93

Last modified by: $Author: marche $
File name:        $Source: /users/demons/demons/master-sources-repository//cime/ocaml_src/theories/acun.mli,v $
Revision:         $Revision: 1.2 $
Last modified on: $Date: 1998/04/28 13:36:44 $

***************************************************************************)

open Symbols
open Terms

(*===============================

(\Theta_{ACUN},\Psi_{ACUN}

================================*)

val theta_acun :
  symbol_id -> symbol_id -> int -> term -> term 
  -> (term * term) list

val couple_normalisant_acun : 
  symbol_id -> symbol_id -> int -> term -> term 
  -> (term * term) list * (term * term) list


val theta_sym_acun :
  symbol_id -> symbol_id -> int -> term -> term 
  -> (term * term) list

val couple_normalisant_sym_acun : 
  symbol_id -> symbol_id -> int -> term -> term 
  -> (term * term) list * (term * term) list

