(***************************************************************************

Calcul du couple_normalisant pour Int(+,0,-,*,1) : interface

CiME Project - Dmons research team - LRI - Universit Paris XI

$Id: int_theory.mli,v 1.2 1998/04/28 13:36:53 marche Exp $

***************************************************************************)

open Symbols;;
open Terms;;
(*
open Equations;;
open Orderings;;
*)

(*===============================

(\Theta_{Int},\Psi_{Int})

Int(un_z coef plus zero moins mult un)

================================*)

val couple_normalisant_int : 
  symbol_id -> symbol_id -> symbol_id -> 
  symbol_id -> symbol_id -> symbol_id -> symbol_id -> 
  term -> term
  -> (term * term) list * (term * term) list
;;

val couple_normalisant_sym_int : 
  symbol_id -> symbol_id -> symbol_id -> 
  symbol_id -> symbol_id -> symbol_id -> symbol_id -> 
  term -> term
  -> (term * term) list * (term * term) list
;;


