(***************************************************************************

(This sentence has been added automatically,
it should be replaced by a description of the module)

CiME Project - Dmons research team - LRI - Universit Paris XI

$Id: abstract_syntax.mli,v 1.8 2002/04/12 15:33:58 marche Exp $

***************************************************************************)


(*

*)

type abstract_expr =
  | Integer of Numbers.t
  | String of string
  | Bool of bool
  | Var of string
  | Fun of string * abstract_expr
  | Apply of abstract_expr * abstract_expr
  | If of abstract_expr * abstract_expr * abstract_expr
  | Tuple of abstract_expr list
  | Set of abstract_expr list
;;

type abstract_command =
    Def of string * abstract_expr
  | Deffun of string * string list * abstract_expr
  | Eval of abstract_expr
  | Directive of string * string
;;

val print_expr : abstract_expr -> unit;;

val print_named_expr : string -> abstract_expr -> unit;;
