(***************************************************************************

  This module provides a function which gives some constraints in
  order to break an occur-check cycle in a quasi-solved problem.

CiME Project - Dmons research team - LRI - Universit Paris XI

$Id: cycle.mli,v 1.7 2002/07/05 12:52:08 contejea Exp $

***************************************************************************)

open Problems

val cycle : 
  'symbol #Signatures.signature -> 'symbol Gen_terms.HashTerm.t -> (*i Variables.user_variables -> i*)
    'symbol problem -> 'symbol problem list

val lazy_cycle : 
  'symbol #Signatures.signature -> 'symbol Gen_terms.HashTerm.t -> (*i Variables.user_variables -> i*)
    'symbol problem -> 'symbol problem Lazy_list.llist



