(***************************************************************************

  Unification modulo an associative and commutative symbol.

CiME Project - Dmons research team - LRI - Universit Paris XI

$Id: unif_ac.mli,v 1.4 2002/07/01 12:01:36 contejea Exp $

***************************************************************************)

open Variables
open Gen_terms
open Theory
open Problems

(*

  [solve elem_pb] computes a unifier for [elem_pb] modulo the
  associativity-commutativity, that is, solves the equations of the
  problem and checks that the constraints of marks are satisfied.

*)

  val solve :
    unif_kind -> 'symbol #Signatures.signature -> 'symbol HashTerm.t ->
      var_id VarSet.t -> 'symbol elem_pb -> 
	('symbol term * 'symbol term) list list



