(***************************************************************************

This module provides functions to test the local confluence of a string
rewriting system.

CiME Project - Dmons research team - LRI - Universit Paris XI

$Id: local_confluence.mli,v 1.4 2002/04/25 10:24:13 monate Exp $

***************************************************************************)


(* Tests if the given string rewriting system is locally
confluent. Note that the result is not correct if the [srs] is not
inter-reduced.*)

val is_localy_confluent : 
  'symbol String_rewriting.srs -> bool

