(***************************************************************************

This module provides functions to complete a string
rewriting system.

CiME Project - Dmons research team - LRI - Universit Paris XI

$Id: srs_completion.mli,v 1.9 2000/10/23 08:54:55 marche Exp $

***************************************************************************)


(* Completion of string-rewriting systems *)

val verbose : int ref;;

open String_signatures;;


val complete_srs_std_strategy :
  'symbol #word_signature ->
  'symbol Words.word Orderings_generalities.ordering ->   
  'symbol String_rewriting.srs -> 
  'symbol String_rewriting.srs 


val complete_srs_alphabetic_order_std_strategy :
  symbol_id #word_signature ->
  symbol_id String_rewriting.srs -> 
  symbol_id String_rewriting.srs 

