(***************************************************************************

This module defines the strings (or words) over a string signature

CiME Project - Dmons research team - LRI - Universit Paris XI

$Id: word_orderings.ml,v 1.3 2000/10/23 15:03:22 marche Exp $

***************************************************************************)



(*

 

*)
open Orderings_generalities;;

let length_lex prec =  
  fun w1 w2 -> 
    let r1 = List.length w1 in
    let r2 = List.length w2 in
      if r1=r2 
      then lexicographic_extension prec w1 w2 
      else if r1<r2 then Less_than else Greater_than
	
let multi_lex prec =
  fun w1 w2 ->
    let c = multiset_extension prec w1 w2 in
    if c = Equivalent 
    then lexicographic_extension prec w1 w2
    else c
;;

