(***************************************************************************

(This sentence has been added automatically, it should be replaced by a description of the module)

CiME Project - Dmons research team - LRI - Universit Paris XI

$Id: abs_syntax.mli,v 1.3 2001/01/24 16:02:28 contejea Exp $

***************************************************************************)


open Clauses;;

exception Erreur_de_syntaxe of string;;

type lexer_state_type =
    Standard_lexer 
  | Ident_lexer 
  | Term_lexer 
  | Include_lexer 
  | Input_clause_lexer
;;

type type_etat_analyse =
     {
       mutable numero_ligne : int;
       mutable numero_colonne_avant : int;
       mutable numero_colonne_apres : int;
       mutable dernier_token_lu : string;
       mutable lexer_state : lexer_state_type
     }
;;

val etat_analyse : type_etat_analyse;;

type abstract_syntax =
    Abstract_include of string
  | Abstract_clause of clause
;;





