(***************************************************************************

(This sentence has been added automatically, it should be replaced by a description of the module)

CiME Project - Dmons research team - LRI - Universit Paris XI

$Id: terms.mli,v 1.4 2002/05/14 14:15:54 contejea Exp $

***************************************************************************)

open Symbols;;

(*===========================

Le type terme, ses constructeurs
et observateurs

===========================*)

type term = 
    Var of var_id 
  | Term of symbol_id * (term list)
;;

val first_var : unit -> term;;
val next_var : unit -> term;;

(*========================================

Fonctions d'aplatissement.

aplatir aplati enti\`erement un terme, et aplatir_en_tete n'effectue
l'aplatissement qu'en t\^ete.

========================================*)

val flatten_term : term -> term;;
val head_flatten_term : term -> term;;
val flatten_term_list : symbol_id -> term list -> term list;;


(*===========================================
Conversion d'un terme en chaine de caracteres
===========================================*)

val string_of_term : term -> string;;

