
/*
#define DEBUG
*/

/*
#define NO_FREE
*/

/**/
#define USE_FAILWITH
/**/

#include <stdio.h>
#include <stdlib.h>

#if defined(USE_FAILWITH)
void failwith(char *s);
#endif

/*
 *	macros
 */
#define MALLOC(t)       ((t *) malloc(sizeof(t)))
#define CALLOC(n, t)    ((t *) calloc(n,sizeof(t)))

#if defined(NO_FREE)
#define FREE(t)         (0)
#else
#define FREE(t)         (free((void *) t))
#endif

/*
define STRSAVE(s)      (strcpy((char *) malloc((unsigned) strlen(s)+1),s))
*/

#if defined(USE_FAILWITH)
#define ASSERT(c, m)    if(!(c)) failwith(m)
#else
#define ASSERT(c, m)    if(!(c)) fatal(c, m)
#endif

#define REALLOC(p, n, t) ((t *) realloc((void *) p, \
				(unsigned) (n) * sizeof(t)))



#define same_head(s,t) (s->type == t->type && s->sym == t->sym)
