(***************************************************************************

(This sentence has been added automatically,
it should be replaced by a description of the module)

CiME Project - Dmons research team - LRI - Universit Paris XI

$Id: profiling_tools.ml,v 1.4 2001/06/05 17:59:14 monate Exp $

***************************************************************************)



let memory_byte () = 
  let stat   = Gc.stat ()
  and control = Gc.get () in
  let max_words_total = 
    float stat.Gc.heap_words +. float control.Gc.minor_heap_size 
  in  ((max_words_total *. float Sys.word_size) /. 8. )

let memory_kb () = ((memory_byte ()) +. 1023.) /. 1024.
