
(* [new_rewrite_at_top] and [new_compiled_rewrite_at_top] are the same as [Standard_rewriting.rewrite_at_top] and [Standard_rewriting.compiled_rewrite_at_top], except they return the whole rewrite rule applied for the reduction instead of just the right member.
*)
val new_rewrite_at_top :
  'symbol Rewrite_rules.t list ->
  'symbol Gen_terms.term -> 
  'symbol Rewrite_rules.t * 'symbol Substitution.substitution

val new_compiled_rewrite_at_top :
  'symbol Naive_dnet.dnet ->
  'symbol Gen_terms.term ->
  'symbol Rewrite_rules.t * 'symbol Substitution.substitution

(* [traced_innermost_normalize sigma red t], with [red] returning the whole (numbered) rewrite rule, is the same as [Innermost.innermost_normalize sigma red' t], except it returns a trace of the normalization as well.
*)
val traced_innermost_normalize :
  'symbol Gen_terms.HashTerm.t ->
  ('symbol Gen_terms.term -> 'symbol Rewrite_rules.t * 'symbol Substitution.substitution) ->
  'symbol Gen_terms.term ->
  'symbol Gen_terms.term * 'symbol Trace.t
