(***************************************************************************

AC unification : body

CiME Project - Dmons research team - LRI - Universit Paris XI

$Id: ac_unifiers.ml,v 1.1 2000/05/16 17:36:34 monate Exp $

***************************************************************************)





open Terms;;
open Substitution;;

(*================

[ac_unifiers s t] returns a list of substitutions 

[ac_unifiers_with_sharing f sl List.tl] do the same with terms [f(sl)]
[f(List.tl)] where [sl] and [List.tl] are linear combination of terms. It uses
sharing to reduce the complexity of the unification problem.

================*)


let ac_unifiers s t = 
(*
printf "J'appelle l'unificateur sur les termes %s et %s\n"
  (string_of_term s) (string_of_term t);
*)
let csu = Unification.set_of_unifiers s t
in
(* 
  printf "CSU obtenu:\n";
  List.iter (fun s -> printf "%s\n" (string_of_substitution s)) csu;
  flush stdout;
*)
  csu
;;


(*
let ac_unifiers_with_sharing n s t =
  let v = List.fold_left Listutils.union 
      	     []
      	     (List.map (fun (t,n) -> variables_du_terme t) (s@t))
  in
  let l = List.map build_subst (ac_unifiers_with_sharing_in_C (new_var v) n s t) in
(*
  printf "CSU obtenu:\n";
  List.iter (fun s -> printf "%s\n" (string_of_substitution s)) l;
  flush stdout;
*)
  l
;;
*)

(*
let ac_unifiers s t =
  let m = (ac_unifiers_in_C (new_var (variables_de_liste_de_termes [s;t])) s t) in
(*
  printf "CSU:\n";
  List.iter (fun theta ->
     List.iter (fun (v,t) ->
       printf "%s --> %s\n" (string_of_term (VAR v)) (string_of_term t)) 
       theta;
     printf "---------\n") m;
  flush stdout;
*)
  let l = List.map build_subst m in
(*
  printf "CSU obtenu:\n";
  List.iter (fun s -> printf "%s\n" (string_of_substitution s)) l;
  flush stdout;
*)
  l
;;
*)



