(***************************************************************************

(This sentence has been added automatically, it should be replaced by a description of the module)

CiME Project - Dmons research team - LRI - Universit Paris XI

$Id: messages.ml,v 1.1 2000/05/16 17:36:45 monate Exp $

***************************************************************************)




open Format
open Args

let sprintf s = Printf.sprintf s

let message s =
  print_string s;
  force_newline();
  print_flush()

let rec ask question answers help = 
  print_string question;
  print_flush();
  let answer = 
    try 
      read_line()
    with 
	End_of_file -> raise Errors.Abort
  in
    begin
    if options_courantes.echo_input
      then begin
           print_string ("<ECHO>" ^ answer ^"</ECHO>");
	   print_newline();
           print_flush()
           end;
    if List.mem answer answers
      then answer
      else begin
      	   print_string help;
           force_newline();
           ask question answers help
	   end
    end

