(***************************************************************************

(This sentence has been added automatically, it should be replaced by a description of the module)

CiME Project - Dmons research team - LRI - Universit Paris XI

$Id: positions.mli,v 1.2 2000/10/11 14:10:11 contejea Exp $

***************************************************************************)

(*
$Id: positions.mli,v 1.2 2000/10/11 14:10:11 contejea Exp $
*)

type position =
    Top
  | Pos of int * position



val string_of_position : position -> string


(*===================================

[build_pos p i] returns position p.i

====================================*)

val build_pos :  position -> int -> position


(*====================================================

  decompose_pos est la function inverse de build_pos.

======================================================*)


val decompose_pos : position -> position * int


(*====================================================

  allonge p.i.p' p retourne p.i, et dans tous les autres
  cas, leve l'exception No_more_pos

======================================================*)

exception No_more_pos

val allonge : position -> position -> position

val is_smaller_pos : position -> position -> bool

