(***************************************************************************

(This sentence has been added automatically, it should be replaced by a description of the module)

CiME Project - Dmons research team - LRI - Universit Paris XI

$Id: unification.mli,v 1.1 2000/05/16 17:36:51 monate Exp $

***************************************************************************)


open Terms;;
open Substitution;;

(*===================

[set_of_unifiers s t] returns the set of most general unifiers of [s]
and [t] according to the current unification theory

===================*)

val select_ac_only_unification : unit -> unit;;

val select_ac_complete_unification : unit -> unit;;

val select_plain_unification : unit -> unit;;

val save_unif_type : unit -> unit;;

val restore_unif_type : unit -> unit;;

val set_of_unifiers : term -> term -> substitution list;;

val are_unifiable : term -> term -> bool;;

(*=============================

Statistics

[unification_stats() returns a pair (c,d) of int where

c = number of calls to unification
d = number of solutions generated

================================*)

val unification_stats : unit -> int * int;;

val unification_times: unit -> float * float;;

