(***************************************************************************

(This sentence has been added automatically,
it should be replaced by a description of the module)

CiME Project - Dmons research team - LRI - Universit Paris XI

$Id: main.ml,v 1.3 2001/05/15 09:08:06 marche Exp $

***************************************************************************)


open Signatures;;
open Variables;;
open Gen_terms;;
open User_terms;;
open Rewrite_rules;;
open Format;;


let vars = Variables.from_string "x y z";;

let sig1 = User_signatures.from_string 
  "* : infix binary ; 
   + : AC;
   0 : constant ; 
   s : unary ;";;

let r = rule_set_of_string sig1 vars 
  "x+0 -> 0;
   x+s(y) -> 0;
   x*0 -> 0;
   x*s(y) -> 0;
   x+x -> 0;";;

print_rewrite_rule_set sig1 vars r;;
print_newline();;

let dnet = Naive_dnet.compile sig1 r;;
Naive_dnet.print sig1 dnet;;

let sig2 =  User_signatures.from_string 
  "#, vrai, faux : constant;
   0,1 : postfix unary;
   +,*,sup  : infix binary;
   ";;


let r2 = rule_set_of_string sig2 vars "
x + # -> x;
# + x -> x;
(x)0 + (y)0 -> (x+y)0;
(x)0 + (y)1 -> (x+y)1;
(x)1 + (y)0 -> (x+y)1;
(x)1 + (y)1 -> (x+y+(#)1)0;
";;

let dnet2 = Naive_dnet.compile sig2 r2;;
printf"-----------------------------------------@.";;
Naive_dnet.print sig2 dnet2;;




  
