(***************************************************************************

Standard matching

CiME Project - Dmons research team - LRI - Universit Paris XI

$Id: standard_matching.mli,v 1.1 2001/07/12 09:08:11 contejea Exp $

***************************************************************************)



open Gen_terms;;
open Substitution;;


(* [(matching pattern subject)] returns the most general filter of
  [subject] over [pattern]. Raises [No_match] if no match is found.

   This is standard matching : all symbols are assumed to be free.

*)

exception No_match;;

val matching : 'symbol term -> 'symbol term -> 'symbol substitution;;








