(***************************************************************************

Fonctions de conversions de termes en chaine de caracteres : interface

CiME Project - Dmons research team - LRI - Universit Paris XI

$Id: pretty_printing.mli,v 1.2 1998/04/28 13:36:09 marche Exp $

***************************************************************************)

(*

Obsolete header:

Project:                Cime
Author(s):             Claude March\'e

File name:        termstr.mli
Created on:              03 fev 93
Last modified on: 18 oct 1995

***************************************************************************)

open Terms
open Equations
open Substitution

(*===========================================

Affichage d'un terme, d'une \'equation 
ou d'une r\`egle dans des box imbriquees.
Format special pour les symboles AC.

===========================================*)

val print_term : term -> unit

val term_of_string : string -> term

val print_equation : equation -> unit

val print_liste_d_equations : equation list -> unit 

val print_regle : regle -> unit

val print_liste_de_regles : regle list -> unit

val string_of_substitution :
  substitution 
  -> string

val print_substitution :
  substitution 
  -> unit


(*===========================================

Conversion d'une chaine de caracteres en terme

Effectuee par la grammaire dans parser.mly 

============================================*)

val term_of_string : string -> term

























