(***************************************************************************

MAPO term ordering : specification

CiME Project - Dmons research team - LRI - Universit Paris XI

$Id: mapo.mli,v 1.2 1998/04/28 13:36:11 marche Exp $

***************************************************************************)

(*

This module implements partially the mapo ordering described in

	Extensions of the Assocative Path Orderings to a Chain of
		Associative Commutative Symbols
	C. Delor and L. Puel
	RTA'93, LNCS 690, pp. 389 -- 404

The order defined here is the one described in Section 4.1.

*)

open Orderings
open Symbols
open Terms
open Rpo

val mapo: precedence * (symbol_id -> rpo_status) -> term ordering
