(***************************************************************************

Term orderings: specification

CiME Project - Dmons research team - LRI - Universit Paris XI

$Id: term_orderings.mli,v 1.5 2001/01/31 16:08:33 monate Exp $

***************************************************************************)


open Orderings;;
open Symbols;;
open Terms;;
open Rpo;;
open Poly_interp;;
open Equations;;


type ordre_disponible =
    ORDRE_INTERACTIF
  | RPO of (precedence_description list) * ((symbol_id * rpo_status) list)
  | MAPO of (precedence_description list)* ((symbol_id * rpo_status) list)
  | POLY of int * (symbol_id * IntPolynomials.poly) list
  | LEXICO of (ordre_disponible list)
  | SEMI_INTERACTIF of ordre_disponible
  | Rps of ordre_disponible * regle list 
;;

(*i
val string_of_ordre : ordre_disponible -> string;;
i*)

val print_ordre : ordre_disponible -> unit;;

val ordre_of_ordre_disponible : ordre_disponible -> term ordering;;


