(***************************************************************************

Checking termination of a rewrite system by the basic criterion

CiME Project - Dmons research team - LRI - Universit Paris XI

$Id: basic_criterion.mli,v 1.6 2002/07/01 12:01:36 contejea Exp $

***************************************************************************)

(*

  [(all_decreasing > R)] returns [true] if all rules of [R] are
  strictly decreasing w.r.t to [>]. If not, prints the first rule
  found that does not decrease and returns [false].

*)
 
(*
\begin{verbatim}
val all_decreasing :
  Terms.term Orderings.ordering -> Equations.regle list -> bool;;
\end{verbatim}
*)

(*

  [(all_decreasing_constraints R)] returns the list of ordering
  constraints that should be satisfied for that each rule of [R] is
  strictly decreasing.

*)
 
val all_decreasing_constraints :
  'symbol Rewrite_rules.t list -> 
  'symbol Termination_constraints.conj_termination_constraints;;


