(***************************************************************************

This module defines the class of sorts

CiME Project - Dmons research team - LRI - Universit Paris XI

$Id: sorts.ml,v 1.1 2000/10/30 16:48:48 monate Exp $

***************************************************************************)



type sort_id = int
type sort_table = string array
 
class type sort = 
      object
	val sort_table : sort_table
	method string_of_sort : sort_id -> string
      end


class from_list (l : string list) =
  object
    val sort_table = Array.of_list l
    method string_of_sort s = sort_table.(s)
  end

class from_string (l : string) =
  object
    val sort_table:sort_table = Array.of_list 
				  (assert false) (* I need a lexer here *)
    method string_of_sort s = sort_table.(s)
  end
