(***************************************************************************

This module defines the class of sorts

CiME Project - Dmons research team - LRI - Universit Paris XI

$Id: sorts.mli,v 1.1 2000/10/30 16:48:48 monate Exp $

***************************************************************************)



type sort_id
type sort_table
		 
class type sort = 
      object
	val sort_table : sort_table
	method string_of_sort : sort_id -> string
      end

(*

  [new from_list l] returns a class sort whose sort names are the
  strings in the list [l]. Example : [new from_list ["nat";"int"]]

*) 

class from_list : string list -> sort;;

(*

  [new from_string s] returns a class sort obtained by the
  syntactical analysis of string s. Example : [new from_string "nat int"]

*) 

class from_string : string -> sort;;
