(***************************************************************************

Calcul du couple_normalisant pour ACU(+,0) : interface

CiME Project - Dmons research team - LRI - Universit Paris XI

$Id: acu.mli,v 1.2 1998/04/28 13:36:42 marche Exp $

***************************************************************************)

(*

Obsolete header:

Project:                Cime
Created on:             04 mai 93

Last modified by: $Author: marche $
File name:        $Source: /users/demons/demons/master-sources-repository//cime/ocaml_src/theories/acu.mli,v $
Revision:         $Revision: 1.2 $
Last modified on: $Date: 1998/04/28 13:36:42 $


***************************************************************************)

open Symbols
open Terms

(*===============================

(\Theta_{ACU},\Psi_{ACU}

================================*)

(* 
substitutions_a_interdire plus t retourne toutes les variables x telles
que le motif x plus ? apparait dans t, modulo AC(plus). 
*)

val substitutions_a_interdire : 
  symbol_id -> term -> var_id list

(*
  instancie_par_zero zero u v x retourne le couple de termes (u,v) 
  instancie par la substitution {x\-> zero}
*)

val instancie_par_zero : 
  symbol_id -> term -> term -> var_id 
  -> term * term

val theta_acu : 
  symbol_id -> symbol_id -> term -> term 
  -> (term * term) list

val couple_normalisant_acu : 
  symbol_id -> symbol_id -> term -> term 
  -> (term * term) list * (term * term) list

val theta_sym_acu : 
  symbol_id -> symbol_id -> term -> term 
  -> (term * term) list

val couple_normalisant_sym_acu : 
  symbol_id -> symbol_id -> term -> term ->
 (term * term) list * (term * term) list 

