(***************************************************************************

Calcul du couple_normalisant pour AG(+,0,-) : interface

CiME Project - Dmons research team - LRI - Universit Paris XI

$Id: ag.mli,v 1.2 1998/04/28 13:36:46 marche Exp $

***************************************************************************)

(*

Obsolete header:


Project:                Cime
Created on:             04 mai 93

Last modified by: $Author: marche $
File name:        $Source: /users/demons/demons/master-sources-repository//cime/ocaml_src/theories/ag.mli,v $
Revision:         $Revision: 1.2 $
Last modified on: $Date: 1998/04/28 13:36:46 $

***************************************************************************)

open Symbols;;
open Terms;;


(*
instancie_par_oppose moins u v x retourne
le couple de termes (u,v) instancie par la substitution {x\-> moins x}
*)

val instancie_par_oppose : 
  symbol_id -> term -> term -> var_id -> term * term;;

(*
instancie_par_somme plus u v x' x retourne
le couple de termes (u,v) instancie par la substitution {x\-> x plus x'}
*)

val instancie_par_somme : 
  symbol_id -> term -> term -> var_id -> var_id 
  -> term * term;;

(*===============================

(\Theta_{AG},\Psi_{AG})

================================*)

val sigma_1 :
  symbol_id -> symbol_id -> symbol_id -> term -> term 
  -> (term * term) list
;;

val theta_ag :
  symbol_id -> symbol_id -> symbol_id -> term -> term 
  -> (term * term) list
;;

val couple_normalisant_ag : 
  symbol_id -> symbol_id -> symbol_id -> term -> term 
  -> (term * term) list * (term * term) list
;;

val theta_sym_ag :
  symbol_id -> symbol_id -> symbol_id -> term -> term 
  -> (term * term) list
;;

val couple_normalisant_sym_ag : 
  symbol_id -> symbol_id -> symbol_id -> term -> term 
  -> (term * term) list * (term * term) list
;;

