(***************************************************************************

(This sentence has been added automatically,
it should be replaced by a description of the module)

CiME Project - Dmons research team - LRI - Universit Paris XI

$Id: predef.mli,v 1.7 2002/06/03 15:46:47 urbain Exp $

***************************************************************************)


open Abstract_syntax;;
open Values;;



val initial_env : unit -> env_type;;
val initial_env_type : unit -> Typing.typing_env_type;;
val get_code : string -> (int * (values list -> values));;


(* Returns the list of the predefined category names.*)

val get_predef_category_list : unit -> string list 

(* Returns the list of the predefined command names in the given category.*)

val get_predef_command_list : string -> string list 

(* Returns the category and the help string associated to a command name.*)

val get_help_of_command : string -> string * string

(* Returns the type of the function associated to a command name.*)

val get_type_of_command : string -> Typing.type_scheme
 
