(***************************************************************************

This module provides two versions of a function which implements the
E-Resolution, that is solves an elementary (pure) problem according to
its theory. The first one is a standard one and the second one is a
lazy one.

CiME Project - Dmons research team - LRI - Universit Paris XI

$Id: e_res.mli,v 1.7 2002/07/05 12:52:08 contejea Exp $

***************************************************************************)

open Signatures
open Problems

val general_E_resolution : 
  'symbol #signature -> (*i Variables.user_variables -> i*) 
    'symbol problem -> 'symbol problem list

val lazy_general_E_resolution : 
  'symbol #signature -> (*i Variables.user_variables -> i*) 
    'symbol problem -> 'symbol problem Lazy_list.llist



