(***************************************************************************

  This module provides a function for cleaning a solved problem, that is
  removing the equations giving the value of an existentially quantified 
  variable.

CiME Project - Dmons research team - LRI - Universit Paris XI

$Id: eqe.mli,v 1.3 2000/11/07 14:28:59 contejea Exp $

***************************************************************************)

open Gen_terms
open Problems

val existential_quantifiers_elimination : 
  'symbol problem -> ('symbol term * 'symbol term) list


