(***************************************************************************

(This sentence has been added automatically,
it should be replaced by a description of the module)

CiME Project - Dmons research team - LRI - Universit Paris XI

$Id: user_theory.ml,v 1.2 2001/04/20 13:42:39 marche Exp $

***************************************************************************)


let do_parse parse_function sigma s =
  try
    Theory_syntax.current_signature := sigma;
    let b = Lexing.from_string s in
      parse_function Theory_lexer.token b
  with
      Parsing.Parse_error -> 
	raise (Theory.Syntax_error "")
    | Failure "lexing: empty token" -> 
	raise (Theory.Syntax_error "invalid character")
    | Theory_lexer.Invalid_char s ->
	raise (Theory.Syntax_error ("invalid character '"^s^"'"))


let from_string sigma s = do_parse Theory_parser.theory sigma s


